/*
 * LCDCharacters.c
 *
 *  Created on: Jul 8, 2015
 *      Author: RK
 */

#include <SI_EFM8UB1_Register_Enums.h>		// SFR declarations
#include "USBVCPCommunication_Defs.h"

/*The LCD expects data in least-significant-bit-first format, whereas the EFM8 can only perform
most-significant-bit-first SPI transfers. This look-up table allows us to use a normal 8-bit variable
for the address: the address is used as the index to this array, and the corresponding array value
is a bit-reversed address that can be sent out the SPI*/
code unsigned char LCDLineAddr_LUT[] =
{
  0x80, 0x40, 0xC0, 0x20, 0xA0, 0x60, 0xE0, 0x10, 0x90, 0x50, 0xD0, 0x30, 0xB0, 0x70, 0xF0,
  0x08, 0x88, 0x48, 0xC8, 0x28, 0xA8, 0x68, 0xE8, 0x18, 0x98, 0x58, 0xD8, 0x38, 0xB8, 0x78, 0xF8,
  0x04, 0x84, 0x44, 0xC4, 0x24, 0xA4, 0x64, 0xE4, 0x14, 0x94, 0x54, 0xD4, 0x34, 0xB4, 0x74, 0xF4,
  0x0C, 0x8C, 0x4C, 0xCC, 0x2C, 0xAC, 0x6C, 0xEC, 0x1C, 0x9C, 0x5C, 0xDC, 0x3C, 0xBC, 0x7C, 0xFC,
  0x02, 0x82, 0x42, 0xC2, 0x22, 0xA2, 0x62, 0xE2, 0x12, 0x92, 0x52, 0xD2, 0x32, 0xB2, 0x72, 0xF2,
  0x0A, 0x8A, 0x4A, 0xCA, 0x2A, 0xAA, 0x6A, 0xEA, 0x1A, 0x9A, 0x5A, 0xDA, 0x3A, 0xBA, 0x7A, 0xFA,
  0x06, 0x86, 0x46, 0xC6, 0x26, 0xA6, 0x66, 0xE6, 0x16, 0x96, 0x56, 0xD6, 0x36, 0xB6, 0x76, 0xF6,
  0x0E, 0x8E, 0x4E, 0xCE, 0x2E, 0xAE, 0x6E, 0xEE, 0x1E, 0x9E, 0x5E, 0xDE, 0x3E, 0xBE, 0x7E, 0xFE,
  0x01
};

code unsigned char LCD_A[CHAR_HEIGHT] = {0xFF, 0x83, 0x01, 0x79, 0x79, 0x79, 0x01, 0x79, 0x79, 0x79};

code unsigned char LCD_B[CHAR_HEIGHT] = {0xFF, 0x03, 0x39, 0x3D, 0x39, 0x03, 0x39, 0x3D, 0x39, 0x03};

code unsigned char LCD_C[CHAR_HEIGHT] = {0xFF, 0xC1, 0x9F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x9F, 0xC1};

code unsigned char LCD_D[CHAR_HEIGHT] = {0xFF, 0x07, 0x33, 0x39, 0x39, 0x39, 0x39, 0x39, 0x33, 0x07};

code unsigned char LCD_E[CHAR_HEIGHT] = {0xFF, 0x01, 0x3F, 0x3F, 0x3F, 0x03, 0x3F, 0x3F, 0x3F, 0x01};

code unsigned char LCD_F[CHAR_HEIGHT] = {0xFF, 0x01, 0x3F, 0x3F, 0x3F, 0x03, 0x3F, 0x3F, 0x3F, 0x3F};

code unsigned char LCD_G[CHAR_HEIGHT] = {0xFF, 0xC1, 0x9D, 0x3F, 0x3F, 0x61, 0x39, 0x39, 0x99, 0xC1};

code unsigned char LCD_H[CHAR_HEIGHT] = {0xFF, 0x39, 0x39, 0x39, 0x39, 0x01, 0x39, 0x39, 0x39, 0x39};

code unsigned char LCD_I[CHAR_HEIGHT] = {0xFF, 0x01, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0x01};

code unsigned char LCD_J[CHAR_HEIGHT] = {0xFF, 0xF9, 0xF9, 0xF9, 0xF9, 0xF9, 0xF9, 0x79, 0x33, 0x87};

code unsigned char LCD_K[CHAR_HEIGHT] = {0xFF, 0x39, 0x33, 0x27, 0x0F, 0x1F, 0x0F, 0x27, 0x33, 0x39};

code unsigned char LCD_L[CHAR_HEIGHT] = {0xFF, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x01};

code unsigned char LCD_M[CHAR_HEIGHT] = {0xFF, 0x7D, 0x39, 0x11, 0x45, 0x6D, 0x7D, 0x7D, 0x7D, 0x7D};

code unsigned char LCD_N[CHAR_HEIGHT] = {0xFF, 0x7D, 0x3D, 0x1D, 0x0D, 0x45, 0x61, 0x71, 0x79, 0x7D};

code unsigned char LCD_O[CHAR_HEIGHT] = {0xFF, 0xC7, 0x93, 0x39, 0x39, 0x7D, 0x39, 0x39, 0x93, 0xC7};

code unsigned char LCD_P[CHAR_HEIGHT] = {0xFF, 0x03, 0x39, 0x39, 0x39, 0x03, 0x3F, 0x3F, 0x3F, 0x3F};

code unsigned char LCD_Q[CHAR_HEIGHT] = {0xFF, 0xC7, 0x93, 0x7D, 0x7D, 0x7D, 0x6D, 0x75, 0x93, 0xC4};

code unsigned char LCD_R[CHAR_HEIGHT] = {0xFF, 0x03, 0x39, 0x39, 0x39, 0x03, 0x0F, 0x27, 0x33, 0x31};

code unsigned char LCD_S[CHAR_HEIGHT] = {0xFF, 0x81, 0x3F, 0x1F, 0x8F, 0xC7, 0xE3, 0xF1, 0xF9, 0x03};

code unsigned char LCD_T[CHAR_HEIGHT] = {0xFF, 0x01, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF, 0xEF};

code unsigned char LCD_U[CHAR_HEIGHT] = {0xFF, 0x39, 0x39, 0x39, 0x39, 0x39, 0x39, 0x39, 0x11, 0x83};

code unsigned char LCD_V[CHAR_HEIGHT] = {0xFF, 0x39, 0x39, 0x39, 0x39, 0x39, 0x93, 0x93, 0xC7, 0xC7};

code unsigned char LCD_W[CHAR_HEIGHT] = {0xFF, 0x7D, 0x7D, 0x6D, 0x29, 0x29, 0xAB, 0x83, 0x93, 0x93};

code unsigned char LCD_X[CHAR_HEIGHT] = {0xFF, 0x7D, 0x39, 0x11, 0x93, 0xC7, 0x93, 0x11, 0x39, 0x7D};

code unsigned char LCD_Y[CHAR_HEIGHT] = {0xFF, 0x7D, 0x7D, 0x39, 0x93, 0xC7, 0xC7, 0xEF, 0xEF, 0xEF};

code unsigned char LCD_Z[CHAR_HEIGHT] = {0xFF, 0x01, 0xF9, 0xF1, 0xE3, 0xC7, 0x8F, 0x1F, 0x3F, 0x01};

code unsigned char LCD_SPACE[CHAR_HEIGHT] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};


