/*
 * USBInterface.c
 *
 *  Created on: Jul 14, 2015
 *      Author: RK
 */

#include <SI_EFM8UB1_Register_Enums.h>                  // SFR declarations
#include "VCPXpress.h"
#include "descriptor.h"
#include "USBVCPCommunication_Defs.h"

uint16_t xdata USBBytesReceived=0;                   // Holds size of received packet
uint8_t xdata USBRxPacket[USB_PACKET_SIZE];     // Packet received from host
bit USB_PACKET_RECEIVED = FALSE;


/**************************************************************************//**
 * VCPXpress callback
 * This function is called by VCPXpress.
 *****************************************************************************/
VCPXpress_API_CALLBACK(myAPICallback)
{
   uint32_t API_InterruptCode;

   //get the code that indicates the reason for the interrupt
   API_InterruptCode = Get_Callback_Source();

   //if the USB connection was just opened
   if (API_InterruptCode & DEVICE_OPEN)
   {
	   //start the first USB read procedure
	   Block_Read(USBRxPacket, USB_PACKET_SIZE, &USBBytesReceived);
	   /*we will process the received bytes when we get
	   a callback with an RX_COMPLETE interrupt code*/
   }

   if (API_InterruptCode & RX_COMPLETE)   // USB read complete
   {
	   /*this flag tells the while loop in USBVCPCommunication_main.c
	     to process a received USB packet*/
	   USB_PACKET_RECEIVED = TRUE;

	   //continue with the next USB read procedure
	   Block_Read(USBRxPacket, USB_PACKET_SIZE, &USBBytesReceived);
   }

}

void ProcessUSBRxPacket()
{
	unsigned char n;

	LCDAllClear();

	for (n = 0;  n < USBBytesReceived; n++)        // Copy received packet to output buffer
	 {
		 switch(USBRxPacket[n])
		 {
		 	 case 'A':
		 		 InsertCharacter(LCD_A);
		 		 break;
		 	 case 'B':
		 		 InsertCharacter(LCD_B);
		 		 break;
		 	 case 'C':
		 		 InsertCharacter(LCD_C);
		 		 break;
		 	 case 'D':
		 		 InsertCharacter(LCD_D);
		 		 break;
		 	 case 'E':
		 		 InsertCharacter(LCD_E);
		 		 break;
		 	 case 'F':
		 		 InsertCharacter(LCD_F);
		 		 break;
		 	 case 'G':
		 		 InsertCharacter(LCD_G);
		 		 break;
		 	 case 'H':
		 		 InsertCharacter(LCD_H);
		 		 break;
		 	 case 'I':
		 		 InsertCharacter(LCD_I);
		 		 break;
		 	 case 'J':
		 		 InsertCharacter(LCD_J);
		 		 break;
		 	 case 'K':
		 		 InsertCharacter(LCD_K);
		 		 break;
		 	 case 'L':
		 		 InsertCharacter(LCD_L);
		 		 break;
		 	 case 'M':
		 		 InsertCharacter(LCD_M);
		 		 break;
		 	 case 'N':
		 		 InsertCharacter(LCD_N);
		 		 break;
		 	 case 'O':
		 		 InsertCharacter(LCD_O);
		 		 break;
		 	 case 'P':
		 		 InsertCharacter(LCD_P);
		 		 break;
		 	 case 'Q':
		 		 InsertCharacter(LCD_Q);
		 		 break;
		 	 case 'R':
		 		 InsertCharacter(LCD_R);
		 		 break;
		 	 case 'S':
		 		 InsertCharacter(LCD_S);
		 		 break;
		 	 case 'T':
		 		 InsertCharacter(LCD_T);
		 		 break;
		 	 case 'U':
		 		 InsertCharacter(LCD_U);
		 		 break;
		 	 case 'V':
		 		 InsertCharacter(LCD_V);
		 		 break;
		 	 case 'W':
		 		 InsertCharacter(LCD_W);
		 		 break;
		 	 case 'X':
		 		 InsertCharacter(LCD_X);
		 		 break;
		 	 case 'Y':
		 		 InsertCharacter(LCD_Y);
		 		 break;
		 	 case 'Z':
		 		 InsertCharacter(LCD_Z);
		 		 break;
		 	 case ' ':
		 		 InsertCharacter(LCD_SPACE);
		 		 break;
		 }
	 }
}


